//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%45A2A585007F.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%45A2A585007F.cm

//## begin module%45A2A585007F.cp preserve=no
//## end module%45A2A585007F.cp

//## Module: EDF%45A2A585007F; Package specification
//## Subsystem: XSFit::StatMethod::EDF%45A2A53C02B8
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/StatMethod/EDF/EDF.h

#ifndef EDF_H
#define EDF_H 1

//## begin module%45A2A585007F.additionalIncludes preserve=no
//## end module%45A2A585007F.additionalIncludes

//## begin module%45A2A585007F.includes preserve=yes
#include <xsTypes.h>
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSFit/Fit/Fit.h>
#include <XSModel/Data/SpectralData.h>
#include <XSModel/Data/Detector/Response.h>
#include <XSModel/Data/BackCorr/Background.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSModel/GlobalContainer/DataSetTypes.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/GlobalContainer/ModelTypes.h>
#include <XSModel/Model/Model.h>
#include <iostream>
#include <iomanip>
#include <set>
//## end module%45A2A585007F.includes

// StatMethod
#include <XSFit/Fit/StatMethod.h>
//## begin module%45A2A585007F.declarations preserve=no
//## end module%45A2A585007F.declarations

//## begin module%45A2A585007F.additionalDeclarations preserve=yes
//## end module%45A2A585007F.additionalDeclarations


//## begin EDF%45A2A6660188.preface preserve=yes
//## end EDF%45A2A6660188.preface

//## Class: EDF%45A2A6660188; Parameterized Class
//## Category: XSFit::StatMethod::EDF%45A5175B01EC
//## Subsystem: XSFit::StatMethod::EDF%45A2A53C02B8
//## Persistence: Transient
//## Cardinality/Multiplicity: n



template <typename Strategy>
class EDF : public StatMethod  //## Inherits: <unnamed>%45A2A73E0089
{
  //## begin EDF%45A2A6660188.initialDeclarations preserve=yes
  //## end EDF%45A2A6660188.initialDeclarations

  private:
    //## Class: SpecFactors%45A7C5FB027D; private
    //## Category: XSFit::StatMethod::EDF%45A5175B01EC
    //## Subsystem: XSFit::StatMethod::EDF%45A2A53C02B8
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::pair<size_t,RealArray> SpecFactors;

    //## Class: FactorContainer%45A7C67401E5; private
    //	Key = spectrum number, Value = pair consisting of
    //	starting position in m_accumulated arrays and area*time
    //	factors.
    //## Category: XSFit::StatMethod::EDF%45A5175B01EC
    //## Subsystem: XSFit::StatMethod::EDF%45A2A53C02B8
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::map<size_t,SpecFactors> FactorContainer;

  public:
    //## Constructors (generated)
      EDF();

    //## Destructor (generated)
      virtual ~EDF();


    //## Other Operations (specified)
      //## Operation: clone%45A2AA710103
      virtual StatMethod* clone () const;

      //## Operation: fullName%45A2AA9C00D5
      virtual const string& fullName () const;

      //## Operation: scriptName%45A2AABA0104
      //	return string used to denote stat method while plotting.
      //
      //	abstract.
      virtual const string& scriptName () const;

    // Additional Public Declarations
      //## begin EDF%45A2A6660188.public preserve=yes
      //## end EDF%45A2A6660188.public

  protected:

    //## Other Operations (specified)
      //## Operation: doPerform%45A3C7E901E3
      virtual void doPerform (Fit* fit);

      //## Operation: doDeallocate%45AE580802FE
      virtual void doDeallocate ();

    // Additional Protected Declarations
      //## begin EDF%45A2A6660188.protected preserve=yes
      //## end EDF%45A2A6660188.protected

  private:
    //## Constructors (generated)
      EDF(const EDF< Strategy > &right);

    //## Assignment Operation (generated)
      EDF< Strategy > & operator=(const EDF< Strategy > &right);


    //## Other Operations (specified)
      //## Operation: doReport%45A2AAE40108
      virtual void doReport (Fit* fit) const;

      //## Operation: doReset%45A2AB020055
      virtual void doReset (Fit* fit);

      //## Operation: getDifferences%45A2AB280026
      virtual ArrayContainer getDifferences (const Fit* fit) const;

      //## Operation: adjustForFrozen%45A2AB4D0294
      virtual std::pair<Real,Real> adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen);

      //## Operation: accumulateCounts%45A3B86B0136
      void accumulateCounts (Fit* fit);

      //## Operation: accumulateModel%45A3B893018F
      void accumulateModel (Fit* fit);

    // Additional Private Declarations
      //## begin EDF%45A2A6660188.private preserve=yes
      //## end EDF%45A2A6660188.private

  private: //## implementation

    //## Other Operations (specified)
      //## Operation: doInitialize%45A3B6FD0243
      virtual void doInitialize (Fit* fit);

    // Data Members for Class Attributes

      //## Attribute: accumulatedCounts%45A3B7EC0029
      //## begin EDF::accumulatedCounts%45A3B7EC0029.attr preserve=no  private: RealArray {U} 
      RealArray m_accumulatedCounts;
      //## end EDF::accumulatedCounts%45A3B7EC0029.attr

      //## Attribute: accumulatedModel%45A3B82D0031
      //## begin EDF::accumulatedModel%45A3B82D0031.attr preserve=no  private: RealArray {U} 
      RealArray m_accumulatedModel;
      //## end EDF::accumulatedModel%45A3B82D0031.attr

      //## Attribute: totalCounts%45B53AFC0387
      //## begin EDF::totalCounts%45B53AFC0387.attr preserve=no  private: Real {U} 
      Real m_totalCounts;
      //## end EDF::totalCounts%45B53AFC0387.attr

    // Additional Implementation Declarations
      //## begin EDF%45A2A6660188.implementation preserve=yes
      FactorContainer m_cachedFactors;
      //## end EDF%45A2A6660188.implementation
};

//## begin EDF%45A2A6660188.postscript preserve=yes
//## end EDF%45A2A6660188.postscript

// Parameterized Class EDF 

// Parameterized Class EDF 

template <typename Strategy>
EDF<Strategy>::EDF()
  //## begin EDF::EDF%45A2A6660188_const.hasinit preserve=no
  //## end EDF::EDF%45A2A6660188_const.hasinit
  //## begin EDF::EDF%45A2A6660188_const.initialization preserve=yes
  : StatMethod(Strategy::fullName),
    m_totalCounts(.0)
  //## end EDF::EDF%45A2A6660188_const.initialization
{
  //## begin EDF::EDF%45A2A6660188_const.body preserve=yes
   isDerivAnalytic(false);
  //## end EDF::EDF%45A2A6660188_const.body
}

template <typename Strategy>
EDF<Strategy>::EDF(const EDF<Strategy> &right)
  //## begin EDF::EDF%45A2A6660188_copy.hasinit preserve=no
  //## end EDF::EDF%45A2A6660188_copy.hasinit
  //## begin EDF::EDF%45A2A6660188_copy.initialization preserve=yes
  : StatMethod(right),
    m_accumulatedCounts(right.m_accumulatedCounts),
    m_accumulatedModel(right.m_accumulatedModel),
    m_totalCounts(right.m_totalCounts),
    m_cachedFactors(right.m_cachedFactors)
  //## end EDF::EDF%45A2A6660188_copy.initialization
{
  //## begin EDF::EDF%45A2A6660188_copy.body preserve=yes
  //## end EDF::EDF%45A2A6660188_copy.body
}


template <typename Strategy>
EDF<Strategy>::~EDF()
{
  //## begin EDF::~EDF%45A2A6660188_dest.body preserve=yes
  //## end EDF::~EDF%45A2A6660188_dest.body
}



//## Other Operations (implementation)
template <typename Strategy>
StatMethod* EDF<Strategy>::clone () const
{
  //## begin EDF::clone%45A2AA710103.body preserve=yes
   return new EDF<Strategy>(*this);
  //## end EDF::clone%45A2AA710103.body
}

template <typename Strategy>
const string& EDF<Strategy>::fullName () const
{
  //## begin EDF::fullName%45A2AA9C00D5.body preserve=yes
   return Strategy::fullName;
  //## end EDF::fullName%45A2AA9C00D5.body
}

template <typename Strategy>
const string& EDF<Strategy>::scriptName () const
{
  //## begin EDF::scriptName%45A2AABA0104.body preserve=yes
   return Strategy::scriptName;
  //## end EDF::scriptName%45A2AABA0104.body
}

template <typename Strategy>
void EDF<Strategy>::doReport (Fit* fit) const
{
  //## begin EDF::doReport%45A2AAE40108.body preserve=yes
  int degrees (0);
  size_t bins(0);
  degreesOfFreedom(fit,degrees,bins);
  using namespace std;
  ios_base::fmtflags saveFmt(tcout.flags());
  tcout << "\n " << Strategy::fullName << " = " << setw(14) << statistic() << " using " 
                  << bins << " PHA bins and " << degrees 
                  << " degrees of freedom." << endl;
  tcout.flags(saveFmt);
  //## end EDF::doReport%45A2AAE40108.body
}

template <typename Strategy>
void EDF<Strategy>::doReset (Fit* fit)
{
  //## begin EDF::doReset%45A2AB020055.body preserve=yes
   using namespace XSContainer;
   std::set<string>::iterator ss (fit->activeModels().begin());
   std::set<string>::iterator ssEnd (fit->activeModels().end());
   while ( ss != ssEnd)
   {
         models->calculate(*ss);
         models->fold(*ss);
	 ++ss;
   }   
  //## end EDF::doReset%45A2AB020055.body
}

template <typename Strategy>
ArrayContainer EDF<Strategy>::getDifferences (const Fit* fit) const
{
  //## begin EDF::getDifferences%45A2AB280026.body preserve=yes
   ArrayContainer differences;
   XSContainer::SpectralDataMapConstIt itSp = fit->spectraToFit().begin();
   XSContainer::SpectralDataMapConstIt itSpEnd = fit->spectraToFit().end();
   while (itSp != itSpEnd)
   {
      const size_t specNum = itSp->first;
      const SpectralData* pSpec = itSp->second;
      const std::valarray<size_t>& IN = pSpec->indirectNotice();
      const size_t sz = IN.size();
      const size_t pos = m_cachedFactors.find(specNum)->first;
      RealArray& diffArray = differences[specNum];
      diffArray.resize(sz);
      diffArray = m_accumulatedCounts[std::slice(pos,sz,1)];
      diffArray -= m_accumulatedModel[std::slice(pos,sz,1)];
      ++itSp;
   }
   return differences;
  //## end EDF::getDifferences%45A2AB280026.body
}

template <typename Strategy>
std::pair<Real,Real> EDF<Strategy>::adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen)
{
  //## begin EDF::adjustForFrozen%45A2AB4D0294.body preserve=yes
  std::pair<Real,Real> fSums (0.,0.);
  static size_t iSpecCount = 1;
  static Real totModCounts = .0;
  static Real totFrozenCounts = .0;
  const size_t nFitSpecs = XSContainer::fit->spectraToFit().size();
  
  // Assume all information set in doInitialize is current.
  // Need to keep track of the total model counts (which includes
  // the contributions from frozen norms).  In this context, the 
  // order these are analyzed is unimportant.
  const std::valarray<size_t>& IN = spec->indirectNotice();
  const size_t N = IN.size(); 
  const size_t specNum = spec->spectrumNumber();
  RealArray totalModel(.0,N);
  RealArray totalModFroz(.0,N);
  for (size_t i=0; i<models.size(); ++i)
  {
     Model* mod = models[i];
      std::map<Model*,ArrayContainer >::const_iterator itSaved =
                savedValsForFrozen.find(mod);
      if (itSaved != savedValsForFrozen.end())
      {
         totalModel += itSaved->second.find(specNum)->second[IN];
         totalModFroz += mod->foldedModel(specNum)[IN];
      }
      else
      {
         totalModel += mod->foldedModel(specNum)[IN];
      }     
  }
  totalModel *= spec->areaScale()[IN];
  totalModel *= spec->exposureTime();
  totalModFroz *= spec->areaScale()[IN];
  totalModFroz *= spec->exposureTime();
  totModCounts += totalModel.sum();
  totFrozenCounts += totalModFroz.sum();
  
  // This is a rather inelegant way of dealing with the fact that 
  // StatMethod::renormalize calls this function once for every fit 
  // spectrum, since that's what other statistics need.  EDF stats
  // however can only calculate adjustment at the end.  So just return
  // zeros until called for the last spectrum.  Also, CAN'T ASSUME that
  // renormalize is sending the spectra in numbered order.
  
  if (iSpecCount == nFitSpecs)
  {
     // The final renorm factor should be: 
     // (totalPhaCounts - frozenNormCounts)/(totalModCounts - frozenNormCounts)
     fSums.first = m_totalCounts - totFrozenCounts;
     fSums.second = totModCounts - totFrozenCounts;
     totModCounts = .0;
     totFrozenCounts = .0;
     iSpecCount = 1;
  }
  else
  {     
     ++iSpecCount;
  }
  return fSums;
  //## end EDF::adjustForFrozen%45A2AB4D0294.body
}

template <typename Strategy>
void EDF<Strategy>::doInitialize (Fit* fit)
{
  //## begin EDF::doInitialize%45A3B6FD0243.body preserve=yes
   StatMethod::doInitialize(fit);
   m_cachedFactors.clear();
   size_t pos = 0;
   XSContainer::SpectralDataMapConstIt itSp = fit->spectraToFit().begin();
   XSContainer::SpectralDataMapConstIt itSpEnd = fit->spectraToFit().end();
   while (itSp != itSpEnd)
   {
      const size_t specNum = itSp->first;
      const SpectralData* pSpec = itSp->second;
      const std::valarray<size_t>& IN = pSpec->indirectNotice();
      SpecFactors& specFacts = m_cachedFactors[specNum];
      specFacts.first = pos;
      specFacts.second.resize(IN.size());
      specFacts.second = pSpec->exposureTime()*pSpec->areaScale()[IN];
      pos += IN.size();
      ++itSp;
   }
   m_accumulatedCounts.resize(pos, .0);
   m_accumulatedModel.resize(pos, .0); 
   accumulateCounts(fit);
   
  //## end EDF::doInitialize%45A3B6FD0243.body
}

template <typename Strategy>
void EDF<Strategy>::accumulateCounts (Fit* fit)
{
  //## begin EDF::accumulateCounts%45A3B86B0136.body preserve=yes
   //This is only called per each initialization.  
   XSContainer::SpectralDataMapConstIt itSp = fit->spectraToFit().begin();
   XSContainer::SpectralDataMapConstIt itSpEnd = fit->spectraToFit().end();
   while (itSp != itSpEnd)
   {
      const SpecFactors& specFacts = m_cachedFactors[itSp->first];      
      const SpectralData* pSpec = itSp->second;
      const std::valarray<size_t>& IN = pSpec->indirectNotice();
      RealArray spectrum(pSpec->spectrum()[IN]);
      if (pSpec->background())
      {
         spectrum -= pSpec->background()->spectrum()[IN];
      }
      if (pSpec->correction() && pSpec->correctionScale())
      {
         spectrum -= pSpec->correctionScale()*pSpec->correction()->spectrum()[IN];
      }
      spectrum *= specFacts.second;
      m_accumulatedCounts[std::slice(specFacts.first,IN.size(),1)] = spectrum;
      ++itSp;
   }
   // Perhaps this will speed things up by doing it C-style.
   const size_t totalSz = m_accumulatedCounts.size();
   Real* pStart = &m_accumulatedCounts[0]; 
   for (size_t i=1; i<totalSz; ++i)
   {
      pStart[i] += pStart[i-1];
   }
   // Normalize
   m_totalCounts = m_accumulatedCounts[totalSz-1];
   m_accumulatedCounts /= m_totalCounts;
     
  //## end EDF::accumulateCounts%45A3B86B0136.body
}

template <typename Strategy>
void EDF<Strategy>::accumulateModel (Fit* fit)
{
  //## begin EDF::accumulateModel%45A3B893018F.body preserve=yes
   // ASSUMES models are all calculated.
   // Unlike accumulateCounts, this gets called every fit iteration.
   // Therefore don't want to resize m_accumulatedModels in here.
   // ASSUME it has been sized properly during the doInitialize phase.
   using namespace XSContainer;
   
   m_accumulatedModel = .0;  
   ModelMapConstIter itMod (models->modelSet().begin());      
   ModelMapConstIter  itModEnd (models->modelSet().end());      
   while (itMod != itModEnd)
   {
      const Model* mod = itMod->second;
      if (mod->isActive())
      {
         ArrayContainer::const_iterator itFolded = mod->foldedModel().begin();
         ArrayContainer::const_iterator itFoldedEnd = mod->foldedModel().end();
         while (itFolded != itFoldedEnd)
         {
            const size_t specNum = itFolded->first;
            const SpectralData* spec = datasets->lookup(specNum);
            const size_t pos = m_cachedFactors[specNum].first;
            const std::valarray<size_t>& IN = spec->indirectNotice();
            m_accumulatedModel[std::slice(pos, IN.size(), 1)]
                   += itFolded->second[IN];
            ++itFolded;
         }
      }
      ++itMod;
   }
   
   // Trying to minimize the number of multiplications by doing
   // this AFTER all folded model arrays have been gathered for
   // each spectrum.
   FactorContainer::const_iterator itFact = m_cachedFactors.begin();
   FactorContainer::const_iterator itFactEnd = m_cachedFactors.end();
   while (itFact != itFactEnd)
   {
      const SpecFactors& specFacts = itFact->second;
      const size_t pos = specFacts.first;
      const RealArray& areaTime = specFacts.second;
      m_accumulatedModel[std::slice(pos, areaTime.size(), 1)]
                *= areaTime;      
      ++itFact;
   }
   const size_t totalSz = m_accumulatedModel.size();
   Real* pStart = &m_accumulatedModel[0];
   for (size_t i=1; i<totalSz; ++i)
   {
      pStart[i] += pStart[i-1];
   }
   m_accumulatedModel /= m_totalCounts;   
  //## end EDF::accumulateModel%45A3B893018F.body
}

template <typename Strategy>
void EDF<Strategy>::doPerform (Fit* fit)
{
  //## begin EDF::doPerform%45A3C7E901E3.body preserve=yes
   doReset(fit);
   accumulateModel(fit);
   Real statVal = Strategy::calculate(m_accumulatedCounts, m_accumulatedModel,
                m_totalCounts);
   
   Real bayesianPrior = bayes().lPrior(fit);           
   statistic(statVal - 2.0*bayesianPrior);
   
  //## end EDF::doPerform%45A3C7E901E3.body
}

template <typename Strategy>
void EDF<Strategy>::doDeallocate ()
{
  //## begin EDF::doDeallocate%45AE580802FE.body preserve=yes
   StatMethod::doDeallocate();
   
   m_accumulatedCounts.resize(0);
   m_accumulatedModel.resize(0);
   m_cachedFactors.clear();  
  //## end EDF::doDeallocate%45AE580802FE.body
}

// Additional Declarations
  //## begin EDF%45A2A6660188.declarations preserve=yes
  //## end EDF%45A2A6660188.declarations

//## begin module%45A2A585007F.epilog preserve=yes
//## end module%45A2A585007F.epilog


#endif
